<?php
/**
 * @file
 * drop_jobs_candidate.features.inc
 */

/**
 * Implements hook_ctools_plugin_api().
 */
function drop_jobs_candidate_ctools_plugin_api() {
  list($module, $api) = func_get_args();
  if ($module == "context" && $api == "context") {
    return array("version" => "3");
  }
  list($module, $api) = func_get_args();
  if ($module == "current_search" && $api == "current_search") {
    return array("version" => "1");
  }
  list($module, $api) = func_get_args();
  if ($module == "field_group" && $api == "field_group") {
    return array("version" => "1");
  }
}

/**
 * Implements hook_views_api().
 */
function drop_jobs_candidate_views_api() {
  return array("version" => "3.0");
}

/**
 * Implements hook_flag_default_flags().
 */
function drop_jobs_candidate_flag_default_flags() {
  $flags = array();
  // Exported flag: "Favorite Candidates".
  $flags['favorite_candidate'] = array(
    'content_type' => 'profile2',
    'title' => 'Favorite Candidates',
    'global' => '0',
    'types' => array(
      0 => 'candidate',
    ),
    'flag_short' => 'Add to favorites',
    'flag_long' => 'Add this candidate to your favorite candidates list.',
    'flag_message' => '',
    'unflag_short' => 'Remove from favorites',
    'unflag_long' => 'Remove this candidate from your favorite candidates list.',
    'unflag_message' => '',
    'unflag_denied_text' => '',
    'link_type' => 'toggle',
    'roles' => array(
      'flag' => array(
        0 => '3',
        1 => '5',
        2 => '4',
      ),
      'unflag' => array(
        0 => '3',
        1 => '5',
        2 => '4',
      ),
    ),
    'weight' => 0,
    'show_on_entity' => 1,
    'show_on_form' => 0,
    'access_author' => '',
    'module' => 'drop_jobs_candidate',
    'locked' => array(
      0 => 'name',
    ),
    'api_version' => 2,
  );
  return $flags;
}

/**
 * Implements hook_default_profile2_type().
 */
function drop_jobs_candidate_default_profile2_type() {
  $items = array();
  $items['candidate'] = entity_import('profile2_type', '{
    "userCategory" : true,
    "userView" : true,
    "type" : "candidate",
    "label" : "R\\u00e9sum\\u00e9",
    "weight" : "0",
    "data" : { "registration" : 0, "use_page" : 1 },
    "rdf_mapping" : []
  }');
  return $items;
}

/**
 * Implements hook_default_rules_link().
 */
function drop_jobs_candidate_default_rules_link() {
  $items = array();
  $items['resume_hide'] = entity_import('rules_link', '{
    "settings" : {
      "text" : "Hide Resume",
      "link_type" : "token",
      "bundles" : { "candidate" : "candidate" },
      "entity_link" : 1
    },
    "name" : "resume_hide",
    "label" : "resume_hide",
    "path" : "resume_hide",
    "entity_type" : "profile2",
    "rdf_mapping" : []
  }');
  return $items;
}
