<?php
/**
 * @file
 * drop_jobs_db.features.inc
 */

/**
 * Implements hook_views_api().
 */
function drop_jobs_db_views_api() {
  return array("version" => "3.0");
}

/**
 * Implements hook_default_search_api_index().
 */
function drop_jobs_db_default_search_api_index() {
  $items = array();
  $items['jobs_db'] = entity_import('search_api_index', '{
    "name" : "Jobs (DB)",
    "machine_name" : "jobs_db",
    "description" : null,
    "server" : "db",
    "item_type" : "node",
    "options" : {
      "index_directly" : 0,
      "cron_limit" : "50",
      "fields" : {
        "type" : { "type" : "string" },
        "title" : { "type" : "text" },
        "status" : { "type" : "boolean" },
        "promote" : { "type" : "boolean" },
        "sticky" : { "type" : "boolean" },
        "created" : { "type" : "date" },
        "changed" : { "type" : "date" },
        "author" : { "type" : "integer", "entity_type" : "user" },
        "field_job_applications" : {
          "type" : "list\\u003Cinteger\\u003E",
          "entity_type" : "drop_jobs_application_type"
        },
        "field_job_experience" : { "type" : "integer", "entity_type" : "taxonomy_term" },
        "field_job_field" : { "type" : "list\\u003Cinteger\\u003E", "entity_type" : "taxonomy_term" },
        "field_job_salary" : { "type" : "integer", "entity_type" : "taxonomy_term" },
        "field_job_study" : { "type" : "list\\u003Cinteger\\u003E", "entity_type" : "taxonomy_term" },
        "field_job_tags" : { "type" : "list\\u003Cinteger\\u003E", "entity_type" : "taxonomy_term" },
        "field_job_type" : { "type" : "integer", "entity_type" : "taxonomy_term" },
        "field_job_location" : { "type" : "text" },
        "field_job_region" : { "type" : "integer", "entity_type" : "taxonomy_term" },
        "field_job_country" : { "type" : "integer", "entity_type" : "taxonomy_term" },
        "field_job_skills" : { "type" : "list\\u003Cinteger\\u003E", "entity_type" : "taxonomy_term" },
        "field_job_company" : { "type" : "integer", "entity_type" : "taxonomy_term" },
        "search_api_language" : { "type" : "string" }
      },
      "data_alter_callbacks" : {
        "search_api_alter_bundle_filter" : {
          "status" : 1,
          "weight" : "-10",
          "settings" : { "default" : "0", "bundles" : { "job" : "job" } }
        },
        "search_api_alter_node_access" : { "status" : 0, "weight" : "0", "settings" : [] },
        "search_api_alter_add_hierarchy" : { "status" : 0, "weight" : "0", "settings" : { "fields" : [] } },
        "search_api_alter_add_aggregation" : { "status" : 0, "weight" : "0", "settings" : [] },
        "search_api_alter_add_url" : { "status" : 0, "weight" : "0", "settings" : [] },
        "search_api_alter_add_viewed_entity" : { "status" : 0, "weight" : "0", "settings" : { "mode" : "full" } }
      },
      "processors" : {
        "search_api_case_ignore" : {
          "status" : 1,
          "weight" : "0",
          "settings" : { "fields" : {
              "title" : true,
              "field_job_field" : true,
              "field_job_study" : true,
              "field_job_type" : true,
              "field_job_location" : true,
              "field_job_region" : true,
              "field_job_country" : true,
              "field_job_skills" : true,
              "field_job_company" : true,
              "search_api_language" : true
            }
          }
        },
        "search_api_html_filter" : {
          "status" : 0,
          "weight" : "10",
          "settings" : {
            "fields" : { "title" : true, "field_job_location" : true },
            "title" : 0,
            "alt" : 1,
            "tags" : "h1 = 5\\r\\nh2 = 3\\r\\nh3 = 2\\r\\nstrong = 2\\r\\nb = 2\\r\\nem = 1.5\\r\\nu = 1.5"
          }
        },
        "search_api_tokenizer" : {
          "status" : 0,
          "weight" : "20",
          "settings" : {
            "fields" : { "title" : true, "field_job_location" : true },
            "spaces" : "[^\\\\p{L}\\\\p{N}^\\u0027]",
            "ignorable" : "[-]"
          }
        },
        "search_api_stopwords" : {
          "status" : 0,
          "weight" : "30",
          "settings" : {
            "fields" : { "title" : true, "field_job_location" : true },
            "file" : "",
            "stopwords" : "but\\r\\ndid\\r\\nthe this that those\\r\\netc"
          }
        }
      }
    },
    "enabled" : "1",
    "read_only" : "0",
    "rdf_mapping" : []
  }');
  $items['resumes_db'] = entity_import('search_api_index', '{
    "name" : "Resumes (DB)",
    "machine_name" : "resumes_db",
    "description" : "Candidate resumes.",
    "server" : "db",
    "item_type" : "profile2",
    "options" : {
      "index_directly" : 0,
      "cron_limit" : "50",
      "fields" : {
        "created" : { "type" : "date" },
        "changed" : { "type" : "date" },
        "field_contact_information" : { "type" : "integer", "entity_type" : "field_collection_item" },
        "field_candidate_education" : {
          "type" : "list\\u003Cinteger\\u003E",
          "entity_type" : "field_collection_item"
        },
        "field_candidate_experience" : {
          "type" : "list\\u003Cinteger\\u003E",
          "entity_type" : "field_collection_item"
        },
        "field_candidate_job_prefs" : { "type" : "integer", "entity_type" : "field_collection_item" },
        "field_candidate_languages" : { "type" : "integer", "entity_type" : "field_collection_item" },
        "field_candidate_personal_info" : { "type" : "integer", "entity_type" : "field_collection_item" },
        "field_candidate_skills" : { "type" : "integer", "entity_type" : "field_collection_item" },
        "field_candidate_complete" : { "type" : "integer" },
        "search_api_language" : { "type" : "string" },
        "field_candidate_education:field_candidate_edu_field" : { "type" : "list\\u003Cinteger\\u003E", "entity_type" : "taxonomy_term" },
        "field_candidate_education:field_candidate_edu_level" : { "type" : "list\\u003Cinteger\\u003E" },
        "field_candidate_education:field_candidate_edu_name" : { "type" : "list\\u003Ctext\\u003E" },
        "field_candidate_education:field_candidate_notes" : { "type" : "list\\u003Ctext\\u003E" },
        "field_candidate_experience:field_candidate_exp_field" : { "type" : "list\\u003Cinteger\\u003E", "entity_type" : "taxonomy_term" },
        "field_candidate_experience:field_candidate_exp_title" : { "type" : "list\\u003Ctext\\u003E" },
        "field_candidate_experience:field_candidate_exp_type" : { "type" : "list\\u003Cinteger\\u003E", "entity_type" : "taxonomy_term" },
        "field_candidate_experience:field_candidate_exp_company" : { "type" : "list\\u003Cinteger\\u003E", "entity_type" : "taxonomy_term" },
        "field_candidate_job_prefs:field_candidate_pref_occupation" : { "type" : "integer", "entity_type" : "taxonomy_term" },
        "field_candidate_job_prefs:field_candidate_pref_start" : { "type" : "date" },
        "field_candidate_job_prefs:field_candidate_pref_title" : { "type" : "text" },
        "field_candidate_job_prefs:field_candidate_pref_country" : { "type" : "integer", "entity_type" : "taxonomy_term" },
        "field_candidate_job_prefs:field_candidate_pref_region" : { "type" : "integer", "entity_type" : "taxonomy_term" },
        "field_candidate_job_prefs:field_candidate_pref_salary" : { "type" : "integer", "entity_type" : "taxonomy_term" },
        "field_candidate_personal_info:field_phone" : {
          "type" : "list\\u003Cinteger\\u003E",
          "entity_type" : "field_collection_item"
        },
        "field_candidate_personal_info:field_first_name" : { "type" : "text" },
        "field_candidate_personal_info:field_last_name" : { "type" : "text" },
        "field_candidate_personal_info:field_date" : { "type" : "date" },
        "field_candidate_personal_info:field_gender" : { "type" : "integer" },
        "field_candidate_personal_info:field_marital_status" : { "type" : "integer" },
        "field_candidate_personal_info:field_schooling" : { "type" : "integer" },
        "field_candidate_skills:field_candidate_notes" : { "type" : "text" },
        "field_candidate_skills:field_candidate_skills_skill" : { "type" : "integer", "entity_type" : "taxonomy_term" },
        "field_candidate_languages:field_candidate_language:term" : { "type" : "integer", "entity_type" : "taxonomy_term" },
        "field_candidate_languages:field_candidate_language:level" : { "type" : "string" }
      },
      "data_alter_callbacks" : {
        "search_api_alter_bundle_filter" : {
          "status" : 1,
          "weight" : "-10",
          "settings" : { "default" : "1", "bundles" : { "candidate" : "candidate" } }
        },
        "search_api_alter_add_hierarchy" : { "status" : 0, "weight" : "0", "settings" : { "fields" : [] } },
        "search_api_alter_add_viewed_entity" : { "status" : 0, "weight" : "0", "settings" : { "mode" : "account" } },
        "search_api_alter_add_aggregation" : { "status" : 0, "weight" : "0", "settings" : [] },
        "search_api_alter_add_url" : { "status" : 0, "weight" : "0", "settings" : [] }
      },
      "processors" : {
        "search_api_case_ignore" : {
          "status" : 1,
          "weight" : "0",
          "settings" : { "fields" : {
              "field_contact_information" : true,
              "field_candidate_education" : true,
              "field_candidate_experience" : true,
              "field_candidate_job_prefs" : true,
              "field_candidate_languages" : true,
              "field_candidate_personal_info" : true,
              "field_candidate_skills" : true
            }
          }
        },
        "search_api_html_filter" : {
          "status" : 0,
          "weight" : "10",
          "settings" : {
            "fields" : [],
            "title" : 0,
            "alt" : 1,
            "tags" : "h1 = 5\\r\\nh2 = 3\\r\\nh3 = 2\\r\\nstrong = 2\\r\\nb = 2\\r\\nem = 1.5\\r\\nu = 1.5"
          }
        },
        "search_api_tokenizer" : {
          "status" : 0,
          "weight" : "20",
          "settings" : {
            "fields" : [],
            "spaces" : "[^\\\\p{L}\\\\p{N}^\\u0027]",
            "ignorable" : "[-]"
          }
        },
        "search_api_stopwords" : {
          "status" : 0,
          "weight" : "30",
          "settings" : {
            "fields" : [],
            "file" : "",
            "stopwords" : "but\\r\\ndid\\r\\nthe this that those\\r\\netc"
          }
        }
      }
    },
    "enabled" : "1",
    "read_only" : "0",
    "rdf_mapping" : []
  }');
  return $items;
}

/**
 * Implements hook_default_search_api_server().
 */
function drop_jobs_db_default_search_api_server() {
  $items = array();
  $items['db'] = entity_import('search_api_server', '{
    "name" : "DB",
    "machine_name" : "db",
    "description" : "",
    "class" : "search_api_db_service",
    "options" : {
      "database" : "default:default",
      "min_chars" : "1",
      "indexes" : {
        "jobs_db" : {
          "type" : {
            "table" : "search_api_db_jobs_db_type",
            "type" : "string",
            "boost" : "1.0"
          },
          "title" : {
            "table" : "search_api_db_jobs_db_title",
            "type" : "text",
            "boost" : "1.0"
          },
          "status" : {
            "table" : "search_api_db_jobs_db_status",
            "type" : "boolean",
            "boost" : "1.0"
          },
          "promote" : {
            "table" : "search_api_db_jobs_db_promote",
            "type" : "boolean",
            "boost" : "1.0"
          },
          "sticky" : {
            "table" : "search_api_db_jobs_db_sticky",
            "type" : "boolean",
            "boost" : "1.0"
          },
          "created" : {
            "table" : "search_api_db_jobs_db_created",
            "type" : "date",
            "boost" : "1.0"
          },
          "changed" : {
            "table" : "search_api_db_jobs_db_changed",
            "type" : "date",
            "boost" : "1.0"
          },
          "author" : {
            "table" : "search_api_db_jobs_db_author",
            "type" : "integer",
            "boost" : "1.0"
          },
          "field_job_applications" : {
            "table" : "search_api_db_jobs_db_field_job_applications",
            "type" : "list\\u003Cinteger\\u003E",
            "boost" : "1.0"
          },
          "field_job_experience" : {
            "table" : "search_api_db_jobs_db_field_job_experience",
            "type" : "integer",
            "boost" : "1.0"
          },
          "field_job_field" : {
            "table" : "search_api_db_jobs_db_field_job_field",
            "type" : "list\\u003Cinteger\\u003E",
            "boost" : "1.0"
          },
          "field_job_salary" : {
            "table" : "search_api_db_jobs_db_field_job_salary",
            "type" : "integer",
            "boost" : "1.0"
          },
          "field_job_study" : {
            "table" : "search_api_db_jobs_db_field_job_study",
            "type" : "list\\u003Cinteger\\u003E",
            "boost" : "1.0"
          },
          "field_job_tags" : {
            "table" : "search_api_db_jobs_db_field_job_tags",
            "type" : "list\\u003Cinteger\\u003E",
            "boost" : "1.0"
          },
          "field_job_type" : {
            "table" : "search_api_db_jobs_db_field_job_type",
            "type" : "integer",
            "boost" : "1.0"
          },
          "field_job_skills" : {
            "table" : "search_api_db_jobs_db_field_job_skills",
            "type" : "list\\u003Cinteger\\u003E",
            "boost" : "1.0"
          },
          "field_job_company" : {
            "table" : "search_api_db_jobs_db_field_job_company",
            "type" : "integer",
            "boost" : "1.0"
          },
          "search_api_language" : {
            "table" : "search_api_db_jobs_db_search_api_language",
            "type" : "string",
            "boost" : "1.0"
          }
        },
        "resumes_db" : {
          "created" : {
            "table" : "search_api_db_resumes_db_created",
            "type" : "date",
            "boost" : "1.0"
          },
          "changed" : {
            "table" : "search_api_db_resumes_db_changed",
            "type" : "date",
            "boost" : "1.0"
          },
          "field_contact_information" : {
            "table" : "search_api_db_resumes_db_field_contact_information",
            "type" : "integer",
            "boost" : "1.0"
          },
          "field_candidate_education" : {
            "table" : "search_api_db_resumes_db_field_candidate_education",
            "type" : "list\\u003Cinteger\\u003E",
            "boost" : "1.0"
          },
          "field_candidate_experience" : {
            "table" : "search_api_db_resumes_db_field_candidate_experience",
            "type" : "list\\u003Cinteger\\u003E",
            "boost" : "1.0"
          },
          "field_candidate_job_prefs" : {
            "table" : "search_api_db_resumes_db_field_candidate_job_prefs",
            "type" : "integer",
            "boost" : "1.0"
          },
          "field_candidate_languages" : {
            "table" : "search_api_db_resumes_db_field_candidate_languages",
            "type" : "list\\u003Cinteger\\u003E",
            "boost" : "1.0"
          },
          "field_candidate_personal_info" : {
            "table" : "search_api_db_resumes_db_field_candidate_personal_info",
            "type" : "integer",
            "boost" : "1.0"
          },
          "field_candidate_skills" : {
            "table" : "search_api_db_resumes_db_field_candidate_skills",
            "type" : "list\\u003Cinteger\\u003E",
            "boost" : "1.0"
          },
          "field_candidate_complete" : {
            "table" : "search_api_db_resumes_db_field_candidate_complete",
            "type" : "integer",
            "boost" : "1.0"
          },
          "search_api_language" : {
            "table" : "search_api_db_resumes_db_search_api_language",
            "type" : "string",
            "boost" : "1.0"
          },
          "field_candidate_education:field_candidate_edu_field" : {
            "table" : "search_api_db_resumes_db_field_candidate_education_field_candid",
            "type" : "list\\u003Cinteger\\u003E",
            "boost" : "1.0"
          },
          "field_candidate_education:field_candidate_edu_level" : {
            "table" : "search_api_db_resumes_db_field_candidate_education_field_cand_1",
            "type" : "list\\u003Cinteger\\u003E",
            "boost" : "1.0"
          },
          "field_candidate_education:field_candidate_edu_name" : {
            "table" : "search_api_db_resumes_db_field_candidate_education_field_cand_2",
            "type" : "list\\u003Ctext\\u003E",
            "boost" : "1.0"
          },
          "field_candidate_education:field_candidate_notes" : {
            "table" : "search_api_db_resumes_db_field_candidate_education_field_cand_3",
            "type" : "list\\u003Ctext\\u003E",
            "boost" : "1.0"
          },
          "field_candidate_experience:field_candidate_exp_field" : {
            "table" : "search_api_db_resumes_db_field_candidate_experience_field_candi",
            "type" : "list\\u003Cinteger\\u003E",
            "boost" : "1.0"
          },
          "field_candidate_experience:field_candidate_exp_title" : {
            "table" : "search_api_db_resumes_db_field_candidate_experience_field_can_1",
            "type" : "list\\u003Ctext\\u003E",
            "boost" : "1.0"
          },
          "field_candidate_experience:field_candidate_exp_type" : {
            "table" : "search_api_db_resumes_db_field_candidate_experience_field_can_2",
            "type" : "list\\u003Cinteger\\u003E",
            "boost" : "1.0"
          },
          "field_candidate_experience:field_candidate_exp_company" : {
            "table" : "search_api_db_resumes_db_field_candidate_experience_field_can_3",
            "type" : "list\\u003Cinteger\\u003E",
            "boost" : "1.0"
          },
          "field_candidate_job_prefs:field_candidate_pref_occupation" : {
            "table" : "search_api_db_resumes_db_field_candidate_job_prefs_field_candid",
            "type" : "integer",
            "boost" : "1.0"
          },
          "field_candidate_job_prefs:field_candidate_pref_start" : {
            "table" : "search_api_db_resumes_db_field_candidate_job_prefs_field_cand_1",
            "type" : "date",
            "boost" : "1.0"
          },
          "field_candidate_job_prefs:field_candidate_pref_title" : {
            "table" : "search_api_db_resumes_db_field_candidate_job_prefs_field_cand_2",
            "type" : "text",
            "boost" : "1.0"
          },
          "field_candidate_job_prefs:field_candidate_pref_salary" : {
            "table" : "search_api_db_resumes_db_field_candidate_job_prefs_field_cand_3",
            "type" : "integer",
            "boost" : "1.0"
          },
          "field_candidate_personal_info:field_phone" : {
            "table" : "search_api_db_resumes_db_field_candidate_personal_info_field_ph",
            "type" : "list\\u003Cinteger\\u003E",
            "boost" : "1.0"
          },
          "field_candidate_personal_info:field_first_name" : {
            "table" : "search_api_db_resumes_db_field_candidate_personal_info_field_fi",
            "type" : "text",
            "boost" : "1.0"
          },
          "field_candidate_personal_info:field_last_name" : {
            "table" : "search_api_db_resumes_db_field_candidate_personal_info_field_la",
            "type" : "text",
            "boost" : "1.0"
          },
          "field_candidate_personal_info:field_date" : {
            "table" : "search_api_db_resumes_db_field_candidate_personal_info_field_da",
            "type" : "date",
            "boost" : "1.0"
          },
          "field_candidate_personal_info:field_gender" : {
            "table" : "search_api_db_resumes_db_field_candidate_personal_info_field_ge",
            "type" : "integer",
            "boost" : "1.0"
          },
          "field_candidate_personal_info:field_marital_status" : {
            "table" : "search_api_db_resumes_db_field_candidate_personal_info_field_ma",
            "type" : "integer",
            "boost" : "1.0"
          },
          "field_candidate_personal_info:field_schooling" : {
            "table" : "search_api_db_resumes_db_field_candidate_personal_info_field_sc",
            "type" : "integer",
            "boost" : "1.0"
          },
          "field_candidate_skills:field_candidate_notes" : {
            "table" : "search_api_db_resumes_db_field_candidate_skills_field_candidate",
            "type" : "list\\u003Ctext\\u003E",
            "boost" : "1.0"
          },
          "field_candidate_skills:field_candidate_skills_skill" : {
            "table" : "search_api_db_resumes_db_field_candidate_skills_field_candida_1",
            "type" : "list\\u003Cinteger\\u003E",
            "boost" : "1.0"
          },
          "field_candidate_languages:field_candidate_language:term" : {
            "table" : "search_api_db_resumes_db_field_candidate_languages_field_candid",
            "type" : "list\\u003Cinteger\\u003E",
            "boost" : "1.0"
          },
          "field_candidate_languages:field_candidate_language:level" : {
            "table" : "search_api_db_resumes_db_field_candidate_languages_field_cand_1",
            "type" : "list\\u003Cstring\\u003E",
            "boost" : "1.0"
          }
        }
      }
    },
    "enabled" : "1",
    "rdf_mapping" : []
  }');
  return $items;
}
